SystemOrganization addCategory: #VisibilityProfiler!
SystemOrganization addCategory: #'VisibilityProfiler-SampleTests'!
SystemOrganization addCategory: #'VisibilityProfiler-Ruby'!

Profiler subclass: #VisibilityProfiler
	instanceVariableNames: 'externalCallerMethodThreshold externalCallerMethodFactorThreshold'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler'!

!VisibilityProfiler class methodsFor: 'hooks' stamp: 'SantiagoVidal 4/30/2012 17:06'!
spyClassForPackage
	 ^ VisibilityProfilerPackage! !

!VisibilityProfiler methodsFor: 'gettersAndSetters' stamp: 'SantiagoVidal 5/1/2012 18:52'!
externalCallerMethodFactorThreshold
	 ^externalCallerMethodFactorThreshold! !

!VisibilityProfiler methodsFor: 'gettersAndSetters' stamp: 'SantiagoVidal 5/1/2012 18:52'!
externalCallerMethodFactorThreshold:aNumber
	externalCallerMethodFactorThreshold:=aNumber.! !

!VisibilityProfiler methodsFor: 'gettersAndSetters' stamp: 'SantiagoVidal 5/1/2012 18:50'!
externalCallerMethodThreshold
	^externalCallerMethodThreshold.! !

!VisibilityProfiler methodsFor: 'gettersAndSetters' stamp: 'SantiagoVidal 5/1/2012 18:49'!
externalCallerMethodThreshold: aNumber
	externalCallerMethodThreshold:=aNumber.! !

!VisibilityProfiler methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/2/2012 12:40'!
initialize
	externalCallerMethodThreshold:=4.
	externalCallerMethodFactorThreshold:=2.! !

!VisibilityProfiler methodsFor: 'hooks' stamp: 'SantiagoVidal 4/30/2012 17:06'!
registryName
	^ #VisibilityProfiler! !

!VisibilityProfiler methodsFor: 'visualization' stamp: 'SantiagoVidal 5/4/2012 15:38'!
visualizeOn: view
	view nodes: self allClasses forEach: [ :each | 
		view shape rectangle borderColor:  [:m | m isCovered ifFalse: [Color yellow] ifTrue: [m isPrivate ifTrue: [ Color black ] ifFalse: [ m isProtected ifTrue: [Color orange] ifFalse: [m isPackaged ifTrue:[Color blue] ifFalse:[m isPrivateWithTests ifTrue: [Color lightGray] ifFalse:[(m isABadEncapsulationCandidateWitZeroOrMoreInterMethods:5) ifTrue: [Color red] ifFalse: [Color green]]] ]]]].
		view nodes: each methods.
		view gridLayout gapSize: 2.
	].
	view edgesFrom: #superclass.
	view treeLayout
	! !

Profiler subclass: #VisibilityRubyProfiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler-Ruby'!

!VisibilityRubyProfiler class methodsFor: 'hooks' stamp: 'SantiagoVidal 5/4/2012 11:16'!
spyClassForPackage
	 ^ VisibilityRubyProfilerPackage! !

!VisibilityRubyProfiler methodsFor: 'hooks' stamp: 'SantiagoVidal 5/4/2012 11:16'!
registryName
	^ #VisibilityRubyProfiler! !

!VisibilityRubyProfiler methodsFor: 'visualization' stamp: 'SantiagoVidal 5/4/2012 11:16'!
visualizeOn: view
	view nodes: self allClasses forEach: [ :each | 
		view nodes: each methods.
		view gridLayout gapSize: 2.
	].
	view edgesFrom: #superclass.
	view treeLayout
	! !

MethodSpy subclass: #VisibilityProfilerMethod
	instanceVariableNames: 'callerMethods isCovered'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler'!

!VisibilityProfilerMethod methodsFor: 'hooks' stamp: 'SantiagoVidal 5/4/2012 15:31'!
beforeRun: methodName with: listOfArguments in: receiver
	isCovered:=true.
	callerMethods add:(self callingMethod).
	! !

!VisibilityProfilerMethod methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 4/30/2012 19:47'!
callerMethods
	^callerMethods.! !

!VisibilityProfilerMethod methodsFor: 'badEncapsulations' stamp: 'SantiagoVidal 5/1/2012 10:48'!
findNumberOfExternalCallerMethods
	^ callerMethods inject: 0 into: [ :result :m | ( (m methodClass == self theClass) |( self theClass subclasses includes: (m methodClass) ) )ifTrue:[result+0] ifFalse: [result+1].]! !

!VisibilityProfilerMethod methodsFor: 'badEncapsulations' stamp: 'SantiagoVidal 5/2/2012 12:54'!
getInternalCallerMethods
	"This method gets all the methods that calls this methods from its own class (or are in the hierarchy)."
	^ callerMethods inject: OrderedCollection new into: [ :result :m | ( (m methodClass == self theClass) or:( self theClass subclasses includes: (m methodClass) ) )ifTrue:[result add:m; yourself ] ifFalse: [result].]! !

!VisibilityProfilerMethod methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/4/2012 15:30'!
initialize
	super initialize.
	callerMethods:=IdentitySet new.
	isCovered:=false.! !

!VisibilityProfilerMethod methodsFor: 'badEncapsulations' stamp: 'SantiagoVidal 5/2/2012 13:24'!
isABadEncapsulationCandidateWitZeroOrMoreInterMethods: aTotalNumberOfInterMethods
	0 to:aTotalNumberOfInterMethods do:[:aNumberOfMethods|
		(self isABadEncapsulationCandidateWithInterMethods: aNumberOfMethods) ifTrue: [^true].
	].
	^false.! !

!VisibilityProfilerMethod methodsFor: 'badEncapsulations' stamp: 'SantiagoVidal 5/2/2012 17:25'!
isABadEncapsulationCandidateWithInterMethods: aNumberOfInterMethods
	"It is a candidate if it is a public method that is called for a few external methods and at least an inner method that has more external methods as caller"
	|externalCallerMethodThreshold externalCallerMethodFactorThreshold|
	externalCallerMethodThreshold:=self profiler externalCallerMethodThreshold.
	externalCallerMethodFactorThreshold:=self profiler externalCallerMethodFactorThreshold.
	self isPublic ifTrue: [
		|numberOfexternalCallerMethods|
		numberOfexternalCallerMethods:=self findNumberOfExternalCallerMethods.
		(numberOfexternalCallerMethods <externalCallerMethodThreshold) ifTrue: [
			|internalCallerMethods interMethodsRemaining|
			
			internalCallerMethods:=self getInternalCallerMethods.
			interMethodsRemaining:=aNumberOfInterMethods.
			[interMethodsRemaining>0]whileTrue: [
				|notPubicMethods filterNotPublicMethods|
				"Filtro solo los metodos que no sean publicos"
				notPubicMethods:=OrderedCollection new.
				filterNotPublicMethods:=false.
				
				internalCallerMethods do:[:anInternalCaller|
					|spyMethod|
					spyMethod:=(self spyMethod:anInternalCaller).
					(spyMethod==nil)ifFalse: [
					filterNotPublicMethods ifFalse: [notPubicMethods add: spyMethod.]
					ifTrue: [
						spyMethod isPublic ifFalse: [
							notPubicMethods add: spyMethod.
						].
					]].
				].
				
				"Cambio el internalCallerMethods por todos los metodos internos que llamaban a los notPublic"
				internalCallerMethods:=OrderedCollection new.
				notPubicMethods do:[:aNotPublicMethod|
					internalCallerMethods addAll: aNotPublicMethod getInternalCallerMethods.
				].
				interMethodsRemaining:=interMethodsRemaining-1.
			].
			
			(internalCallerMethods size >0)ifTrue: [
					internalCallerMethods do:[:anInternalCaller|
						|internalCallerSpyMethod|
						internalCallerSpyMethod:=(self spyMethod:anInternalCaller).
						(internalCallerSpyMethod ==nil) ifFalse:[
						(internalCallerSpyMethod findNumberOfExternalCallerMethods >(numberOfexternalCallerMethods*externalCallerMethodFactorThreshold)) ifTrue: [^true].]
					].
			].
		].
	].
	^false.! !

!VisibilityProfilerMethod methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/4/2012 15:31'!
isCovered 
	^isCovered.! !

!VisibilityProfilerMethod methodsFor: 'kindOfMethod' stamp: 'SantiagoVidal 5/3/2012 17:39'!
isPackaged
	(self isPrivate | self isProtected )ifTrue: [^false].
	^ callerMethods inject: true into: [ :result :m |  result and: [ (m methodClass == self theClass) or: [self methodsInSameCategoryThanMe:m ]] ]! !

!VisibilityProfilerMethod methodsFor: 'kindOfMethod' stamp: 'SantiagoVidal 5/4/2012 16:32'!
isPackagedWithTests
	(self isPrivate | self isProtected | self isPackaged | self isPrivateWithTests | self isProtectedWithTests)ifTrue: [^false].
	^ callerMethods inject: true into: [ :result :m |  result and: [ (m methodClass == self theClass) or:[(self methodsInSameCategoryThanMe:m) or:[m methodClass inheritsFrom:TestCase]]]]! !

!VisibilityProfilerMethod methodsFor: 'kindOfMethod' stamp: 'SantiagoVidal 5/1/2012 09:36'!
isPrivate
	"A method is private if it is called only by methods of its own class or if it is not called for any method"
	^ callerMethods inject: true into: [ :result :m |  result and: [ m methodClass == self theClass ]]
	! !

!VisibilityProfilerMethod methodsFor: 'kindOfMethod' stamp: 'SantiagoVidal 5/4/2012 16:26'!
isPrivateWithTests
	(self isPrivate | self isProtected | self isPackaged)ifTrue: [^false].
	^ callerMethods inject: true into: [ :result :m |  result and: [ (m methodClass == self theClass) or:[m methodClass inheritsFrom:TestCase]]]! !

!VisibilityProfilerMethod methodsFor: 'kindOfMethod' stamp: 'SantiagoVidal 5/2/2012 16:12'!
isProtected
	self isPrivate ifTrue: [^false].
	^ callerMethods inject: true into: [ :result :m |  result and: [ (m methodClass == self theClass) or: [ self theClass subclasses includes: (m methodClass) ]] ]! !

!VisibilityProfilerMethod methodsFor: 'kindOfMethod' stamp: 'SantiagoVidal 5/4/2012 16:28'!
isProtectedWithTests
	(self isPrivate | self isProtected | self isPackaged | self isPrivateWithTests)ifTrue: [^false].
	^ callerMethods inject: true into: [ :result :m |  result and: [ (m methodClass == self theClass) or:[(self theClass subclasses includes: (m methodClass)) or:[m methodClass inheritsFrom:TestCase]]]]! !

!VisibilityProfilerMethod methodsFor: 'kindOfMethod' stamp: 'SantiagoVidal 5/4/2012 17:43'!
isPublic
	self isPrivate ifTrue: [^false].
	self isProtected ifTrue: [^false].
	self isPackaged ifTrue: [^false].
	self isPrivateWithTests ifTrue: [^false].
	self isProtectedWithTests ifTrue: [^false].
	self isPackagedWithTests ifTrue: [^false].
	^true.! !

!VisibilityProfilerMethod methodsFor: 'kindOfMethod' stamp: 'SantiagoVidal 5/3/2012 17:38'!
methodsInSameCategoryThanMe: aCompiledMethod
	|category| 
	(aCompiledMethod methodClass isMeta)ifTrue: [
		category:= aCompiledMethod methodClass soleInstance category] 
	ifFalse: [category:= aCompiledMethod methodClass  category]. 
	^category==(self theClass category)! !

!VisibilityProfilerMethod methodsFor: 'badEncapsulations' stamp: 'SantiagoVidal 5/1/2012 11:52'!
spyMethod: aCompileMethod

	self profiler allMethods do:[:anSpyMethod|
		
	((aCompileMethod methodClass == anSpyMethod theClass) &(aCompileMethod selector ==anSpyMethod selector))ifTrue: [^anSpyMethod].
	].
	^nil.
	"el metodo spy que consiga compiledMethod==aCompileMethod"! !

MethodSpy subclass: #VisibilityRubyProfilerMethod
	instanceVariableNames: 'currentState isCovered'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler-Ruby'!

!VisibilityRubyProfilerMethod class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/4/2012 12:35'!
privateState
	^'private'! !

!VisibilityRubyProfilerMethod class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/4/2012 12:36'!
privateWithTestsState
	^'privateWithTests'! !

!VisibilityRubyProfilerMethod class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/4/2012 12:35'!
protectedState
	^'protected'! !

!VisibilityRubyProfilerMethod class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/4/2012 16:48'!
protectedWithTestsState
	^'protectedWithTests'! !

!VisibilityRubyProfilerMethod class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/4/2012 12:36'!
publicState
	^'public'! !

!VisibilityRubyProfilerMethod class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/4/2012 12:33'!
undefinedState
	^'undefined'! !

!VisibilityRubyProfilerMethod class methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/4/2012 16:49'!
undefinedTestState
	^'undefinedTest'! !

!VisibilityRubyProfilerMethod methodsFor: 'hooks' stamp: 'SantiagoVidal 5/4/2012 17:31'!
beforeRun: methodName with: listOfArguments in: receiver
	| callingObject |
	isCovered:=true.
	callingObject := self callingMethod methodClass.
	
	(self isPublic) ifFalse: [
		(self isUndefinedTest) ifTrue: [
			
			(self senderIsATestClass:callingObject) ifFalse: [
				(self senderAndReceiverAreRelated:callingObject theReceiver:receiver) ifTrue: [
					(receiver == callingObject) ifFalse: [currentState:=VisibilityRubyProfilerMethod protectedWithTestsState.]
						ifTrue: [currentState:=VisibilityRubyProfilerMethod privateWithTestsState.].	
				] ifFalse: [currentState:=VisibilityRubyProfilerMethod publicState.].
			].
		] ifFalse: [
			(self isProtected) ifTrue: [
				(self senderIsATestClass:callingObject) ifTrue: [
					currentState:=VisibilityRubyProfilerMethod protectedWithTestsState.
				] ifFalse: [
					(self senderAndReceiverAreRelated:callingObject theReceiver:receiver) ifFalse: [ 						
						currentState:=VisibilityRubyProfilerMethod publicState.
					]
				].	
			] ifFalse: [
				(self isProtectedWithTests) ifTrue: [
					(self senderIsATestClass:callingObject) ifFalse: [
						(self senderAndReceiverAreRelated:callingObject theReceiver:receiver) ifFalse: [
							currentState:=VisibilityRubyProfilerMethod publicState.
						]
					]
				] ifFalse: [
					(self isPrivate) ifTrue: [
						(self senderIsATestClass:callingObject) ifTrue: [ 
							currentState:=VisibilityRubyProfilerMethod privateWithTestsState.
						] ifFalse: [
							(self senderAndReceiverAreRelated:callingObject theReceiver:receiver) ifTrue: [
								(receiver == callingObject) ifFalse: [currentState:=VisibilityRubyProfilerMethod protectedState]
							] ifFalse: [currentState:=VisibilityRubyProfilerMethod publicState.].
						].
					] ifFalse: [
						(self isPrivateWithTests) ifTrue: [
							(self senderIsATestClass:callingObject) ifFalse: [
								(self senderAndReceiverAreRelated:callingObject theReceiver:receiver) ifTrue: [
									(receiver == callingObject) ifFalse: [currentState:=VisibilityRubyProfilerMethod protectedWithTestsState.]
								] ifFalse: [currentState:=VisibilityRubyProfilerMethod publicState.].
							]
						] ifFalse: [
							(self isUndefined) ifTrue: [
								(self senderIsATestClass:callingObject) ifTrue: [
									currentState:=VisibilityRubyProfilerMethod undefinedTestState.
								] ifFalse: [
									(self senderAndReceiverAreRelated:callingObject theReceiver:receiver) ifTrue: [
										(receiver == callingObject) ifFalse: [currentState:=VisibilityRubyProfilerMethod protectedState.]
											ifTrue: [currentState:=VisibilityRubyProfilerMethod privateState.].	
									] ifFalse: [currentState:=VisibilityRubyProfilerMethod publicState.].
								]
							] ifFalse: [
								self halt. "ERROR"
							]
						]
					]
				]
			]
		]
	]
	! !

!VisibilityRubyProfilerMethod methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/4/2012 15:33'!
initialize 
	super initialize.
	currentState:=VisibilityRubyProfilerMethod undefinedState.
	isCovered:=false.! !

!VisibilityRubyProfilerMethod methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/4/2012 15:32'!
isCovered
	^isCovered.! !

!VisibilityRubyProfilerMethod methodsFor: 'states' stamp: 'SantiagoVidal 5/4/2012 12:36'!
isPrivate
	^currentState =VisibilityRubyProfilerMethod privateState.! !

!VisibilityRubyProfilerMethod methodsFor: 'states' stamp: 'SantiagoVidal 5/4/2012 12:37'!
isPrivateWithTests 
	^currentState =VisibilityRubyProfilerMethod privateWithTestsState.! !

!VisibilityRubyProfilerMethod methodsFor: 'states' stamp: 'SantiagoVidal 5/4/2012 12:37'!
isProtected
	^currentState =VisibilityRubyProfilerMethod protectedState.! !

!VisibilityRubyProfilerMethod methodsFor: 'states' stamp: 'SantiagoVidal 5/4/2012 16:49'!
isProtectedWithTests 
	^currentState =VisibilityRubyProfilerMethod protectedWithTestsState.! !

!VisibilityRubyProfilerMethod methodsFor: 'states' stamp: 'SantiagoVidal 5/4/2012 12:37'!
isPublic 
	^currentState =VisibilityRubyProfilerMethod publicState.! !

!VisibilityRubyProfilerMethod methodsFor: 'states' stamp: 'SantiagoVidal 5/4/2012 12:35'!
isUndefined
	^currentState =VisibilityRubyProfilerMethod undefinedState.! !

!VisibilityRubyProfilerMethod methodsFor: 'states' stamp: 'SantiagoVidal 5/4/2012 16:50'!
isUndefinedTest
	^currentState =VisibilityRubyProfilerMethod undefinedTestState.! !

!VisibilityRubyProfilerMethod methodsFor: 'states' stamp: 'SantiagoVidal 5/4/2012 16:56'!
senderAndReceiverAreRelated: callingObject theReceiver:receiver
	"This methods checks if the caller and the receiver belongs to the same class or if the caller belongs to a subclass of the receiver"
	(receiver == callingObject)ifTrue:[^true].
	(callingObject == self theClass) ifTrue:[^true].
	^(self theClass subclasses includes: callingObject)
	! !

!VisibilityRubyProfilerMethod methodsFor: 'states' stamp: 'SantiagoVidal 5/4/2012 15:16'!
senderIsATestClass:callingObject
	
	^callingObject  inheritsFrom:TestCase.! !

AbstractSpyTest subclass: #VisibilityProfilerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler'!

!VisibilityProfilerTest methodsFor: 'hooks' stamp: 'SantiagoVidal 4/30/2012 17:06'!
profilerClass
	^  VisibilityProfiler! !

!VisibilityProfilerTest methodsFor: 'tests' stamp: 'SantiagoVidal 5/1/2012 09:43'!
testPrivateMethod
	|methods|
	methods:=self runScenario allMethods.
	
	"Private method with 3 callers <TGFoo>>foo1>"
	self assert: (methods at:66) isPrivate.
	
	"Private method with 2 callers <TGFoo>>foo3>"
	self assert: (methods at:61) isPrivate.
	
	"Private method with 0 callers <TGFooSubClass2>>indirectSideEffect:>"
	self assert: (methods at:2) isPrivate.
	
	! !

!VisibilityProfilerTest methodsFor: 'tests' stamp: 'SantiagoVidal 5/1/2012 17:06'!
testPrivateWithTestsMethod
	|methods|
	methods:=self runScenario allMethods.
	
	"<TGCar>>addWheel:> called for tests and classes"
	self assert: (methods at:15) isPrivateWithTests.
	"<TGCar>>driver:> called only for tests"
	self assert: (methods at:16) isPrivateWithTests.
	! !

!VisibilityProfilerTest methodsFor: 'tests' stamp: 'SantiagoVidal 5/1/2012 09:55'!
testProtectedMethod
	|methods|
	methods:=self runScenario allMethods.
	
	"There is not a scenario with a protectred method"
	"Private method with 2 callers <TGFoo>>initialize>"
	
	"self assert: (methods at:59) isProtected."
	
! !

!VisibilityProfilerTest methodsFor: 'tests' stamp: 'SantiagoVidal 5/1/2012 17:05'!
testPublicMethod
	|methods|
	methods:=self runScenario allMethods.
	
	
	"<TGCar>>hash> called only for classes but one of them is a false dependency"
	self assert: (methods at:11) isPublic.
	"<TGCar>>giveMeANewCarForDriver:> called only for classes"
	self assert: (methods at:13) isPublic.! !

AbstractSpyTest subclass: #VisibilityRubyProfilerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler-Ruby'!

!VisibilityRubyProfilerTest methodsFor: 'hooks' stamp: 'SantiagoVidal 5/4/2012 11:16'!
profilerClass
	^  VisibilityRubyProfiler! !

PackageSpy subclass: #VisibilityProfilerPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler'!

!VisibilityProfilerPackage class methodsFor: 'hooks' stamp: 'SantiagoVidal 4/30/2012 17:06'!
spyClassForClass
	 ^ VisibilityProfilerClass! !

PackageSpy subclass: #VisibilityRubyProfilerPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler-Ruby'!

!VisibilityRubyProfilerPackage class methodsFor: 'hooks' stamp: 'SantiagoVidal 5/4/2012 11:16'!
spyClassForClass
	 ^ VisibilityRubyProfilerClass! !

ClassSpy subclass: #VisibilityProfilerClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler'!

!VisibilityProfilerClass class methodsFor: 'hooks' stamp: 'SantiagoVidal 4/30/2012 17:06'!
spyClassForMethod
	 ^ VisibilityProfilerMethod! !

ClassSpy subclass: #VisibilityRubyProfilerClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler-Ruby'!

!VisibilityRubyProfilerClass class methodsFor: 'hooks' stamp: 'SantiagoVidal 5/4/2012 11:16'!
spyClassForMethod
	 ^ VisibilityRubyProfilerMethod! !

Object subclass: #CaseStudies
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler'!

!CaseStudies methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/2/2012 16:48'!
createAreaChartData
|profiler methods|
profiler:=VisibilityProfiler runTestsForPackagesMatching: 'Mondrian*'.
methods:=profiler allMethods.
2 to: 20 do:[:externalCallerMethodThreshold|
	|externalCallerMethodFactorThreshold|
	externalCallerMethodFactorThreshold:=1.
	[externalCallerMethodFactorThreshold<=3.1] whileTrue: [
		|problemsDetected|
		"Transcript show: externalCallerMethodThreshold asString, ' ', externalCallerMethodFactorThreshold asString; cr."
		profiler externalCallerMethodThreshold:externalCallerMethodThreshold.
		profiler externalCallerMethodFactorThreshold:externalCallerMethodFactorThreshold.
		problemsDetected:=methods inject:0 into:[:count :am| (am isABadEncapsulationCandidateWitZeroOrMoreInterMethods:5)ifTrue: [count+1] ifFalse: [count]].
		Transcript show: problemsDetected asString, String tab.
		externalCallerMethodFactorThreshold:=externalCallerMethodFactorThreshold+0.1.
	].
	Transcript show: String cr.
].! !
